
class Components():

	def __init__(self,arbre,can):
		self.arbre=arbre
		self.can=can
		self.composante=[]
		self.dessins=[]
	
	def etiquettearbreacces(self,etiq):		
		if etiq==self.arbre.racine:
			return([self.arbre.racine])
		else:
			parent=self.arbre.proximate(etiq)
			if len(parent)==1:
				Res=self.etiquettearbreacces(parent[0])+[etiq]									
				Res.sort()
			else:
				Res=self.etiquettearbreacces(parent[0])+self.etiquettearbreacces(parent[1])+[etiq]					
				Res=list(set(Res))
				Res.sort()
			return(Res)
	
	def listecomposante(self):
		res=[]
		for l in self.arbre.courbe:
			if l[1]>0:
				L=deepcopy(self.etiquettearbreacces(l[0]))
				C=[[u,0] for u in L]
				C[-1][1]=1
				P=deepcopy(self.arbre.extract(L))
				res+=[ArbreDual(P,L,self.arbre.racine,C)]
		
		for k in range(0,len(res)):
			Amin=ArbreMinimal(res[k])
			Amin.minimize()
			if Amin.arbre.proximite in [u.proximite for u in self.composante]:
				pass
			else:
				self.composante+=[Amin.arbre]
			
			
	
	def dessinecomponents(self):	
		Nb=len(self.composante)
		print(Nb)
		pos=100
		for A in self.composante:		
			self.dessins+=[DessinArbre(self.can,A,[pos,500],[0,1],60,15,1)]			
			pos+=1000.0/Nb
		for l in self.dessins:
			l.graphecoordonnees_calcul()
			l.dessine()	


