################ Module de calcul du jeu des dicritiques

load('Saito.sage')

def Epsilon(P,nu,Delta):
	long=len(nu)
	Dic=[sum([-P[j][i] for j in range(0,i) if Delta[j]==1]) for i in range(0,long)]
	#print(Dic)
	Val=matrix(P).inverse()*matrix([nu[i][1] for i in range(0,long)]).transpose()
	Val=Val.list()
	#print(Val)
	partial=[]
	for k in range(0,long):
		if mod(Val[k]-Dic[k],2)==0:
			partial+=[Delta[k]]
		else:
			partial+=[1/2] 
	ValuationCorrige=[(Val[k]-Dic[k])/2+partial[k] for k in range(0,long)]
	return((matrix(P)*matrix(ValuationCorrige).transpose()).list()) 
	
def DicriticiteSommet(P,nu,Delta):
	Res=[]
	for k in range(0,len(P)):
		DD=deepcopy(Delta)
		DD[k]=1
		Res1=Epsilon(P,nu,DD)[k]
		if Res1>=nu[k][1]:
			Res+=[1]
		else:
			Res+=[0]
	return(Res)

def piece(n):
	if n==1:
		return([[0],[1]])
	else:
		M=piece(n-1) 
		return([[0]+l for l in M]+[[1]+l for l in M])	

def Dicriticite(P,nu):
	L=piece(len(P))
	return([[l,DicriticiteSommet(P,nu,l)] for l in L])
	
def MatriceDicriticite(P,nu):
	Res=matrix(2^len(P))
	Cal=Dicriticite(P,nu)
	Val=piece(len(P))
	for i in range(0,2^len(P)):
		Res[Val.index(Cal[i][1]),i]=1
	print(Res)		
	return(Res.charpoly(),Res,Res.eigenspaces_left())			
