

from tkinter import *
import tkinter

pi=3.14159265358

class EnriquesDiagram():
	def __init__(self,can,arbre,centre,h,rayon,direction,factor):
		self.can=can
		self.arbre=arbre
		self.centre=centre
		self.h=h
		self.rayon=rayon
		self.factor=factor
		self.graphecoordonnees=[]
		self.direction=direction
		self.factor=factor
	
	def norm(self,vec):
		return(sqrt(vec[0]^2+vec[1]^2))

	def directionarc(self,pt1,pt2,direction):
		d=[2*(pt2[0]-pt1[0])-self.factor*direction[0],2*(pt2[1]-pt1[1])-self.factor*direction[1]]		
		return([d[0]/self.norm(d),d[1]/self.norm(d)])

	def arc(self,pt1,pt2,direction,N):
		def gamma(t,pt1,pt2,direction,N):
			pt1=matrix(pt1)
			pt2=matrix(pt2)
			point=t*pt2+(1-t)*pt1+t*(1-t)*(self.factor*matrix(direction)-pt2+pt1)			
			return([point[0][0],point[0][1]])			

		for k in range(0,N):
			self.sommet(gamma(k/(N-1),pt1,pt2,direction,N),0.1,"black")
	
	def sommet(self,centre,rayon,color):
		self.can.create_oval(centre[0]-rayon,centre[1]-rayon,centre[0]+rayon,centre[1]+rayon,fill=color)
		
	def segment(self,pt1,pt2):
		self.can.create_line(pt1[0],pt1[1],pt2[0],pt2[1],width=2)

	def rotation(self,angle,centre,pt):
		return([cos(angle)*(-centre[0]+pt[0])-sin(angle)*(-centre[1]+pt[1])+centre[0],sin(angle)*(-centre[0]+pt[0])+cos(angle)*(-centre[1]+pt[1])+centre[1]])

	def translate(self,pt,vecteur,factor):
		return([pt[0]+factor*vecteur[0],pt[1]+factor*vecteur[1]])

	def graphecoordonnees_calcul(self):
		
		section=1/3		
		
		self.graphecoordonnees+=[[self.centre,self.direction]]
		self.sommet(self.centre,1.5*self.rayon,'black')

		NombreSommetMax=[1-sum(l) for l in self.arbre.proximite] 
		inc=[0 for t in range(0,self.arbre.taille())]
		
		for l in range(1,self.arbre.taille()):
			prox=self.proximate(l)
			if len(prox)==1:
				#print(prox)
				if prox==[0]:
					start=self.graphecoordonnees[0][0]
					direction=self.rotation(2*pi/NombreSommetMax[0]*inc[0],[0,0],self.graphecoordonnees[0][1])
								
					end=self.translate(start,self.rotation(pi/8,[0,0],direction),self.h)					
					#print(end)					
					directionend=self.directionarc(start,end,direction)
					self.graphecoordonnees+=[[end,directionend]]
					self.sommet(end,self.rayon,'black')
					#print(start,end,direction)					
					self.arc(start,end,direction,200)
					inc[0]+=1

				else:	
					start=self.graphecoordonnees[prox[0]][0]
					direction=self.graphecoordonnees[prox[0]][1]				
					end=self.translate(start,self.rotation(2*pi/NombreSommetMax[prox[0]]*inc[prox[0]]*section+pi/4,[0,0],direction),self.h)	
					directionend=self.directionarc(start,end,direction)					
					self.graphecoordonnees+=[[end,directionend]]
					self.sommet(end,self.rayon,'black')
					self.arc(start,end,direction,200)
					inc[prox[0]]+=1					
			if len(prox)==2:
				if self.proximate(prox[1])[0]==prox[0]:
					start=self.graphecoordonnees[prox[1]][0]
					direction=self.graphecoordonnees[prox[1]][1]
					end=self.translate(start,direction,self.h)
					directionend=direction
					self.graphecoordonnees+=[[end,directionend]]
					self.sommet(end,self.rayon,'black')
					self.segment(start,end)
				else:
					start=self.graphecoordonnees[prox[1]][0]
					direction=self.graphecoordonnees[prox[1]][1]
					directionend=self.rotation(inc[prox[1]]*2*pi/NombreSommetMax[prox[1]]*section,start,direction)
					end=self.translate(start,directionend,self.h)						
					self.graphecoordonnees+=[[end,directionend]]
					self.sommet(end,self.rayon,'black')
					self.segment(start,end)
				inc[prox[1]]+=1
		
		for l in range(0,self.arbre.taille()):
			if not self.arbre.courbe[l][1]==0:
				start=self.graphecoordonnees[l][0]
				direction=self.graphecoordonnees[l][1]				
				for i in range(0,self.arbre.courbe[l][1]):
					directionend=self.rotation((i+1)*pi/(3*self.arbre.courbe[l][1]),[0,0],direction)				
					end=self.translate(start,directionend,self.h)
					self.arc(start,end,direction,200)						
					self.sommet(end,self.rayon,'blue')
					
	def proximate(self,i):
		if i==0:
			return([])
		else:
			return([l for l in range(0,self.arbre.taille()) if self.arbre.proximite[l][i]==-1])



		
