from tkinter import *
import tkinter
from tkinter.font import Font
import pickle

load("Arbre.sage")
	
class ArbreDualFeuilletage(ArbreDual):
	def __init__(self,P,E,R,C,dic):
		ArbreDual.__init__(self,P,E,R,C)
		self.dicriticite=dic
		
	def dicritic(self,eti):
		for l in self.dicriticite:
			if l[0]==eti:
				return(l[1])
				
	def sousgrapheFeuilletage(self):
		self.listesousgraphe=[]		
		if self.taille()==1:
			return([])
		else:
			Voisins=self.voisinage(self.racine)			
			for l in Voisins:		
				Res=[]		
				ADD1=[l]
				while not set(Res)==set(ADD1):			
					Res=ADD1
					#print(ADD1)					
					for v in ADD1:
						ajout=self.voisinage(v)							
						if self.racine in ajout:							
							ajout.remove(self.racine)
						ADD1=ADD1+ajout	
					ADD1=list(set(ADD1))					
				Res.sort()				
				#print(eti)
				#print(self.courbe)				
				CC=[]				
				for u in Res:
					CCindex=[f[0] for f in self.courbe].index(u)					
					CC.append(self.courbe[CCindex])						
				self.listesousgraphe.append(ArbreDualFeuilletage(self.extract(Res),Res,l,CC,[[l,self.dicritic(l)] for l in Res]))
		
	def composanteconnexedic(self):
		if self.taille()==1:
			if self.dicritic(self.racine)==0:
				return([])
			else:
				return([[self.racine]])
		else:
			voisins=self.voisinage(self.racine)
			SubGraphe=self.sousgrapheFeuilletage()
			Res=[]
			if self.dicritic(self.racine)==0:
				for l in self.listesousgraphe:
					Res.extend(l.composanteconnexedic())
				return(Res)
			else:
				for l in self.listesousgraphe:
					Res.extend(l.composanteconnexedic())
				#print(Res)
				V=self.voisinage(self.racine)
				Glue=[a for a in Res if InterListe(a,V)]
				#print(Glue)
				Union=[]
				for l in Glue:
					Union.extend(l)
				Union.append(self.racine)
				Union.sort()
				#print(Union)
				for l in Glue:
					Res.remove(l)
				Res.append(Union)
				return(Res)	
			
	def valence(self):
		return([[eti,len(self.voisinage(eti))] for eti in self.etiquette])
		
	def ncourbe(self,eti):
		Ind=[l[0] for l in self.courbe].index(eti)
		return(self.courbe[Ind][1])
		
	def critered(self,eti):
		Vd=sum([self.dicritic(l) for l in self.voisinage(eti)])
		#print(Vd)
		VDmul=sum([self.valuation(l) for l in self.voisinage(eti) if self.dicritic(l)==0])
		#print(VDmul)
		if self.dicritic(eti)==1:
			return(self.valuation(eti)*(self.ncourbe(eti)+Vd-2)-VDmul)
		else:
			return(-(self.valuation(eti)*(self.ncourbe(eti)+Vd-2)-VDmul))
			
	
	def feuilletageminimal(self):
		
		##Variable d'incrémentation
		Incre=self.valence()
		
		## On ajoute une valence technique à la racine
		Ind=[p[0] for p in Incre].index(self.racine)
		Incre[Ind][1]+=1
		
		while sum([l[1] for l in Incre])>0:
			print(Incre)
			for Comp in [l[0] for l in Incre if l[1]==1]:
				#print(Comp)
				
				### On annule la valence de Comp dans Incre
				Ind=[p[0] for p in Incre].index(Comp)
				Incre[Ind][1]+=-1
			
				### On diminue la valence de toutes les composantes attachées à Comp
				for l in self.voisinage(Comp):
					#print(l)
					Ind=[p[0] for p in Incre].index(l)
					#print(Ind)
					if Incre[Ind][1]>0:
						Incre[Ind][1]+=-1
				#print(Incre)
				
				### On teste le critère sur la composante Comp
				if self.critered(Comp)>0:
					Ind=[p[0] for p in self.dicriticite].index(Comp)
					self.dicriticite[Ind][1]=0
					
				### On ajoute des composantes éventuelles aux branches vides des composantes connexes de l'arbre privé des composantes dicritiques.
				for l in self.composanteconnexedic():
					if sum([self.ncourbe(eti) for eti in l])==0:
						Opt=[self.valuation(eti) for eti in l]
						Ind=Opt.index(min(Opt))
						etig=l[Ind][0]
						self.addcourb(etig)
						
	def feuilletageminimal2(self):
		
		##Variable d'incrémentation
		Incre=[[eti,self.critered(eti)] for eti in self.etiquette] 
		print('Dicriticite initiale=',self.dicriticite)
		print('Courbe initiale=',self.courbe)
		print('Valuation initiale=',self.feuilletagevaluation())		
		
		while sum([l>0 for l in [p[1] for p in Incre]])>0:
			m=max([l[1] for l in Incre])
			#print(m)
			Ind=[l[1] for l in Incre].index(m)
			Comp=Incre[Ind][0]
			#print(Comp)
			Ind=[p[0] for p in self.dicriticite].index(Comp)
			self.dicriticite[Ind][1]=0
			#print('Dicriticite=',self.dicriticite)
					
			### On ajoute des composantes éventuelles aux branches vides des composantes connexes de l'arbre privé des composantes dicritiques.
			#print(self.composanteconnexedic())
			for l in self.composanteconnexedic():
				if sum([self.ncourbe(eti) for eti in l])==0:	
					Opt=[self.valuation(eti) for eti in l]
					Ind=Opt.index(min(Opt))
					#print(l,Ind)
					etig=l[Ind]
					self.addcurve([etig])
					
			### On recalcule le critère
			Incre=[[eti,self.critered(eti)] for eti in self.etiquette]
			#print('Incre=',Incre)
			#print(self.feuilletagevaluation())
		
		print('Courbe finale=',self.courbe)
		print('Dicriticite finale=',self.dicriticite)
		print('Valuation finale=',self.feuilletagevaluation())		
	
	def feuilletageminimal3(self):
		
		MinAr=self.dicriticite
		MaxD=sum([l[1] for l in MinAr])
		MinVal=self.arbrecourbevaluation()-1
		MinCourbe=self.courbe
		#print(MinAr,MinVal)
		Inc=pileouface(self.taille())	
		#print(Inc)
		
		for l in Inc:
			A=deepcopy(ArbreDualFeuilletage(self.proximite,self.etiquette,self.racine,self.courbe,self.dicriticite))		
			A.dicriticite=[[A.etiquette[u],l[u]] for u in range(0,self.taille())]
			#print(A.dicriticite)
			for l in A.composanteconnexedic():
				if sum([A.ncourbe(eti) for eti in l])==0:	
					Opt=[A.valuation(eti) for eti in l]
					Ind=Opt.index(min(Opt))
					#print(l,Ind)
					etig=l[Ind]
					A.addcurve([etig])
			if A.feuilletagevaluation()<=MinVal:
				if A.feuilletagevaluation()<MinVal:
					MinAr=A.dicriticite
					MinVal=A.feuilletagevaluation()
					MinCourbe=A.courbe
					MaxD=sum([l[1] for l in MinAr])
				else:
					if sum([l[1] for l in A.dicriticite])<MaxD:
						MinAr=A.dicriticite
						MinVal=A.feuilletagevaluation()
						MinCourbe=A.courbe
						MaxD=sum([l[1] for l in MinAr])	
								
		print([MinAr,MinCourbe,MinVal])
		return([MinAr,MinCourbe,MinVal])		
				
				
	def feuilletagevaluation(self):
		Res=0
		for eti in self.etiquette:
			if self.dicritic(eti)==1:
				Res+=self.valuation(eti)*self.ncourbe(eti)
			if self.dicritic(eti)==0:
				Res+=self.valuation(eti)*(2-sum([self.dicritic(l) for l in self.voisinage(eti)]))
		return(Res-1)	 
	
	def feuilletagevaluationgeneral(self):
		Res=0
		for eti in self.etiquette:
			if self.dicritic(eti)==1:
				Res+=self.valuation(eti)*self.ncourbe(eti)
			if self.dicritic(eti)==0:
				Res+=self.valuation(eti)*(2-sum([self.dicritic(l) for l in self.voisinage(eti)])+self.ncourbe(eti))
		return(Res-1)		
	
	
	def ContributionValuation(self,eti):
		if self.dicritic(eti)==1:
			return(self.valuation(eti)*self.courbe[self.etiquette.index(eti)][1])
		else:
			return(self.valuation(eti)*(2-sum([1 for l in self.voisinage(eti) if self.dicritic(l)==1])))
			
	def TriContribution(self):
		return(TriParametrique([[eti,self.ContributionValuation(eti)] for eti in self.etiquette]))
		
	def MaxContribution(self):
		pass
	
	
	def FeuilletageMinimal(self):
		pass
			
			
def pileouface(n):
	if n==1:
		return([[0],[1]])
	else:
		M=pileouface(n-1)
		return([[0]+l for l in M]+[[1]+l for l in M]) 			
			
def InterListe(A,B):
	for l in A:
		if l in B:
			return(True)
	return(False)	

def TriParametrique(L):
	Res=[]
	if L==[]:
		return([])
	else:
		M=[l[1] for l in L]
		m=max(M)
		#print(m)
		#print(L[M.index(m)])
		A=L[M.index(m)]
		#print(A)
		L.remove(A)
		#print(L)
		Res=[A]
		Res.extend(TriParametrique(L))
	return(Res)

