
load("SemiGroup.sage")

from sage.symbolic.expression_conversions import RingConverter
u=var('u')
conv=RingConverter(R,subs_dict={u:t})
x=var('x')
y=var('y')

####### t est une variable introduite dans Courbes.sage comme variable valuée de l'anneau Q(..)[t]

class IrreducibleCurve():
	def __init__(self,arbre):
		self.arbre=arbre
		self.param=()

	inc=1
	def parametrisation(self):
		coor=[x,y]
		for k in range(0,self.arbre.taille()-1):
			if len(self.arbre.proximate(self.arbre.etiquette[k+1]))==1:
				#print('choix 1')
				coor=[coor[0].subs(x=x*(y+1),y=x),coor[1].subs(x=x*(y+1),y=x)]
			if len(self.arbre.proximate(self.arbre.etiquette[k+1]))==2:
				if self.arbre.proximite[self.arbre.etiquette.index(self.arbre.etiquette[k+1])-2][self.arbre.etiquette.index(self.arbre.etiquette[k+1])]==-1:
					coor=[coor[0].subs(x=x*y,y=x),coor[1].subs(x=x*y,y=x)]
					#print('choix 2')
				else:
					coor=[coor[0].subs(x=x,y=x*y),coor[1].subs(x=x,y=x*y)]
					#print('choix 3')
		coor=[coor[0].subs(x=x*y,y=x),coor[1].subs(x=x*y,y=x)]		
		#print(coor)		
		self.param=(conv(coor[0].subs(x=u,y=1)),conv(coor[1].subs(x=u,y=1)))
		#print(self.param)

	def inverse(self,f,n):
		if n==1:
			return(t)
		else:
			inversetrunc=self.inverse(f,n-1)
			inversetruncU=inversetrunc.subs(t=u)			
			eq=taylor(f.subs(t=inversetruncU),u,0,n)
			eq=conv(eq)
			eq=eq.monomial_coefficient(t^n)
			print(self.arbre.arbrecourbemilnor()-n)
			return(inversetrunc-eq*t^n)
						
			

	def normalisation(self,boo):
		
		x,y = self.param
		print(x,y)
		ordre=self.arbre.arbrecourbemilnor()				
		if x.valuation()<=y.valuation():
			pass
		else:
			y,x=self.param
		
		#print('param',x,y)
			
		val0=x.valuation()
		coeff0=x.monomial_coefficient(t^val0)
		x=x/coeff0		

		if boo:
			x=x.subs(t=u)
			y=y.subs(t=u)
	
			T=taylor(u*(x/u^val0)^(1/val0),u,0,ordre+1)
			#print(T)		
			T=conv(T)
			#print(T)	
			T=self.inverse(T,ordre+1)		
			T=T.subs(t=u)
			#print(T)
		
			y=y.subs(u=T)
			#print(y)
			y=taylor(y,u,0,ordre+1)
			
			x=t^val0
			y=conv(y)

			#print(x,y)				
			#print('ça y est')		

			while (not y==0) and mod(y.valuation(),val0)==0:				
				val=y.valuation()
				y=y-y.monomial_coefficient(t^val)*t^val
		else:
			while (not y==0) and mod(y.valuation(),val0)==0:				
				val=y.valuation()
				y=y-y.monomial_coefficient(t^val)*x^(val/val0)
		

		self.param=(x,y)
		#print(self.param)

M=[[1, -1, -1, 0, 0, 0, 0],
 [0, 1, -1, 0, 0, 0, 0],
 [0, 0, 1, -1, -1, 0, 0],
 [0, 0, 0, 1, -1, 0, 0],
 [0, 0, 0, 0, 1, -1, -1],
 [0, 0, 0, 0, 0, 1, -1],
 [0, 0, 0, 0, 0, 0, 1]]




#A=ArbreDual(M,[1,2,3,4,5,6,7],1,[[1,0],[2,0],[3,0],[4,0],[5,0],[6,0],[7,1]])

#B=IrreducibleCurve(A)
#B.parametrisation()
#B.normalisation()


