
class SaitoInvariant():
	def __init__(self,arbre,courbe,centre,direction,h,rayon,factor):
		self.arbre=arbre
		self.courbe=courbe
		self.eti=0
		self.eti2=0
		self.centre=centre
		self.h=h
		self.rayon=rayon
		self.factor=factor
		self.direction=direction
	
	def etiquettearbreacces(self,etiq):		
		if etiq==self.arbre.racine:
			return([self.arbre.racine])
		else:
			parent=self.arbre.proximate(etiq)
			if len(parent)==1:
				Res=self.etiquettearbreacces(parent[0])+[etiq]									
				return(Res)
			else:
				Res=self.etiquettearbreacces(parent[0])+self.etiquettearbreacces(parent[1])+[etiq]					
				Res=list(set(Res))
				Res.sort()
				return(Res)
			
	def invariantI(self,Val,dic,boo,etiacces):
		vecinit=[sum([dic[l][1] for l in [self.arbre.etiquette.index(k) for k in self.arbre.proximate(u)]]) for u in etiacces]		
		dicr=[dic[l][1] for l in [self.arbre.etiquette.index(k) for k in etiacces]] 		
		if boo==1:
			veci=[l+1 for l in vecinit]
		else:	
			if boo==2:
				veci=[l+1 for l in vecinit]
				veci[0]=2
			else:
				veci=vecinit	
		#print('veci=',veci)		
		#print(Val)
		#print(dicr)			
		part1=sum(veci)/2
		part2=sum([1/2 for l in range(0,len(veci)) if mod(Val[l]-veci[l],2)==1])
		part3=sum([1 for l in range(0,len(veci)) if mod(Val[l]-veci[l],2)==0 and dicr[l]==1])
		return(part1-part2-part3)
		
	def invariantSquare(self,Val,dic,etiacces):
		dicr=[dic[l][1] for l in [self.arbre.etiquette.index(k) for k in etiacces]]
		#print(dicr)
		part1=1/2*(sum(dicr)-dicr[-1])
		
		dicr2=[0]+dicr
		part2=sum([dicr[l] for l in range(0,len(Val)) if mod(Val[l]-dicr2[l],2)==0])
		part3=sum([1/2 for l in range(0,len(Val)) if mod(Val[l]-dicr2[l],2)==1])
		return(part1-part2-part3)

########################### Invariant Square
		
	def square(self):
		def recupere():
			self.eti=int(entree.get())		
			self.fen.destroy()
			self.dessine3()
		
		self.fen=Tk()
		self.fen.title('Label of the acces component')		
		entree = Entry(self.fen, width=30)
		entree.pack()

		bouton = Button(self.fen, text="Valider", command=recupere)
		bouton.pack()
	
		self.fen.mainloop()
		
	def dessine3(self):

		fen=Tk()
		fen.title('Square invariant')	
		can=Canvas(fen,width=1000,height=800,bg="white")

		nouvellesetiquettes=triEtiquette(deepcopy(self.arbre.courbe))
		dicriticite1=Saito(self.arbre.proximite,nouvellesetiquettes)
		etiacces=self.etiquettearbreacces(self.eti)				
		proxacces=self.arbre.extract(etiacces)
		#print(proxacces,etiquette)
		arbresaitoacces=ArbreDual(proxacces,etiacces,self.arbre.racine,self.arbre.courbe)
		dessinsaito=DessinArbre(can,arbresaitoacces,[self.centre[0]-200,self.centre[1]],self.direction,self.h,self.rayon,self.factor)
		#print(etiacces,self.arbre.courbe)
		vec1=[dicriticite1[self.arbre.etiquette.index(l)] for l in etiacces]	
		#print(etiquette,vec)	
		dessinsaito.graphecoordonnees_calcul()
		#print(dessinsaito.graphecoordonnees)
		dessinsaito.dessinesaito(vec1,False,True)		
	
		Val=matrix(self.arbre.proximite).inverse()*matrix([[l[1]] for l in self.arbre.courbe])
		indices=[self.arbre.etiquette.index(l) for l in etiacces]	
		Val=list([Val.transpose()[0][l] for l in indices])			
		
		print(Val)
		print(dicriticite1)
		print(etiacces)
			
		Res=self.invariantSquare(Val,dicriticite1,etiacces)
		can.create_text(250,150,text=str(Val))
		can.create_text(250,200,text='Square = '+str(Res))

		can.pack()
		fen.mainloop()

############ Invariant Theta1
	
	def entreeetiacces(self):
		def recupere():
			self.eti=int(entree.get())		
			self.fen.destroy()
			self.dessine()
		
		self.fen=Tk()
		self.fen.title('Label of the acces component')		
		entree = Entry(self.fen, width=30)
		entree.pack()

		bouton = Button(self.fen, text="Valider", command=recupere)
		bouton.pack()
	
		self.fen.mainloop()

	def dessine(self):

		fen=Tk()
		fen.title('Saito foliation acces')	
		can=Canvas(fen,width=1000,height=800,bg="white")

		nouvellesetiquettes=triEtiquette(deepcopy(self.arbre.courbe))
		dicriticite1=Saito(self.arbre.proximite,nouvellesetiquettes)
		etiacces=self.etiquettearbreacces(self.eti)				
		
		proxacces=self.arbre.extract(etiacces)
		arbresaitoacces=ArbreDual(proxacces,etiacces,self.arbre.racine,self.arbre.courbe)
		dessinsaito=DessinArbre(can,arbresaitoacces,[self.centre[0]-200,self.centre[1]],self.direction,self.h,self.rayon,self.factor)
		vec1=[dicriticite1[self.arbre.etiquette.index(l)] for l in etiacces]		
		dessinsaito.graphecoordonnees_calcul()
		dessinsaito.dessinesaito(vec1,False,True)		
	
		rang=[l[0] for l in nouvellesetiquettes].index(self.eti)
		nouvellesetiquettes[rang][1]+=1
		dicriticite2=Saito(self.arbre.proximite,nouvellesetiquettes)		
		dessinsaito=DessinArbre(can,arbresaitoacces,[self.centre[0],self.centre[1]],self.direction,self.h,self.rayon,self.factor)
		#print(etiacces,self.arbre.courbe)
		vec2=[dicriticite2[self.arbre.etiquette.index(l)] for l in etiacces]	
		#print(etiquette,vec)	
		dessinsaito.graphecoordonnees_calcul()
		#print(dessinsaito.graphecoordonnees)
		dessinsaito.dessinesaito(vec2,False,True)		
		
		Val=matrix(self.arbre.proximite).inverse()*matrix([[l[1]] for l in self.arbre.courbe])
		indices=[self.arbre.etiquette.index(l) for l in etiacces]	
		Val=list([Val.transpose()[0][l] for l in indices])			
			
		Res=self.invariantI(Val,dicriticite1,0,etiacces)+self.invariantI(Val,dicriticite2,1,etiacces)
		can.create_text(250,150,text=str(Val))
		can.create_text(250,200,text='Invariant Theta1 = '+str(Res)+' '+str([self.invariantI(Val,dicriticite1,0,etiacces),self.invariantI(Val,dicriticite2,1,etiacces)]))

		can.pack()
		fen.mainloop()
	
################# Invariant Theta2

	def entreeetiacces2(self):
		def recupere():
			self.eti=int(entree.get())
			self.eti2=int(entree2.get())		
			self.fen.destroy()
			self.dessine2()
		
		self.fen=Tk()
		self.fen.title('Label')		
		
		Label(self.fen, text="Master label").grid(row=0,column=0,sticky=W)		
		Label(self.fen, text="Secondary label").grid(row=1,column=0,sticky=W)				
		entree = Entry(self.fen)				
		entree2 = Entry(self.fen)	
		entree.grid(row=0,column=1)
		entree2.grid(row=1,column=1)	

		bouton = Button(self.fen, text="Valider", command=recupere)
		bouton.grid(row=2,column=1)

		self.fen.mainloop()

	def dessine2(self):

		fen=Tk()
		fen.title('Saito foliation acces')	
		can=Canvas(fen,width=1000,height=800,bg="white")

		nouvellesetiquettes=triEtiquette(deepcopy(self.arbre.courbe))
		dicriticite1=Saito(self.arbre.proximite,nouvellesetiquettes)
		etiacces=self.etiquettearbreacces(self.eti)
		print(etiacces)				
		Val=matrix(self.arbre.proximite).inverse()*matrix([[l[1]] for l in self.arbre.courbe])
		indices=[self.arbre.etiquette.index(l) for l in etiacces]	
		Val=list([Val.transpose()[0][l] for l in indices])			
		Res1=self.invariantSquare(Val,dicriticite1,etiacces)

		proxacces=self.arbre.extract(etiacces)
		arbresaitoacces=ArbreDual(proxacces,etiacces,self.arbre.racine,self.arbre.courbe)
		dessinsaito=DessinArbre(can,arbresaitoacces,[self.centre[0]-200,self.centre[1]],self.direction,self.h,self.rayon,self.factor)
		vec1=[dicriticite1[self.arbre.etiquette.index(l)] for l in etiacces]		
		dessinsaito.graphecoordonnees_calcul()
		dessinsaito.dessinesaito(vec1,False,True)

		rang=[l[0] for l in nouvellesetiquettes].index(self.eti)
		nouvellesetiquettes[rang][1]+=1
		rang=[l[0] for l in nouvellesetiquettes].index(self.eti2)
		nouvellesetiquettes[rang][1]+=1
	
		dicriticite2=Saito(self.arbre.proximite,nouvellesetiquettes)				
		Val2=matrix(self.arbre.proximite).inverse()*matrix([[l[1]] for l in nouvellesetiquettes])
		indices=[self.arbre.etiquette.index(l) for l in etiacces]	
		Val2=list([Val2.transpose()[0][l] for l in indices])	
		Res2=self.invariantSquare(Val2,dicriticite2,etiacces)

		dessinsaito=DessinArbre(can,arbresaitoacces,[self.centre[0],self.centre[1]],self.direction,self.h,self.rayon,self.factor)
		vec1=[dicriticite2[self.arbre.etiquette.index(l)] for l in etiacces]		
		dessinsaito.graphecoordonnees_calcul()
		dessinsaito.dessinesaito(vec1,False,True)


		can.create_text(250,150,text=str(Val))
		can.create_text(250,200,text='Invariant Theta2 = '+str(Res1+Res2+len(etiacces)/2))

		can.pack()
		fen.mainloop()

###################### Invariant Theta11


	def entreeetiacces3(self):
		def recupere():
			self.eti=int(entree.get())
			self.eti2=int(entree2.get())		
			self.fen.destroy()
			self.dessine4()
		
		self.fen=Tk()
		self.fen.title('Label')		
		
		Label(self.fen, text="Master label").grid(row=0,column=0,sticky=W)		
		Label(self.fen, text="Secondary label").grid(row=1,column=0,sticky=W)				
		entree = Entry(self.fen)				
		entree2 = Entry(self.fen)	
		entree.grid(row=0,column=1)
		entree2.grid(row=1,column=1)	

		bouton = Button(self.fen, text="Valider", command=recupere)
		bouton.grid(row=2,column=1)

		self.fen.mainloop()
		
	def dessine4(self):

		fen=Tk()
		fen.title('Saito foliation acces')	
		can=Canvas(fen,width=1000,height=800,bg="white")

		nouvellesetiquettes=triEtiquette(deepcopy(self.arbre.courbe))
		dicriticite1=Saito(self.arbre.proximite,nouvellesetiquettes)
		etiacces=self.etiquettearbreacces(self.eti)
		print(etiacces)				
		Val=matrix(self.arbre.proximite).inverse()*matrix([[l[1]] for l in self.arbre.courbe])
		indices=[self.arbre.etiquette.index(l) for l in etiacces]	
		Val=list([Val.transpose()[0][l] for l in indices])			
		Res1=self.invariantSquare(Val,dicriticite1,etiacces)

		proxacces=self.arbre.extract(etiacces)
		arbresaitoacces=ArbreDual(proxacces,etiacces,self.arbre.racine,self.arbre.courbe)
		dessinsaito=DessinArbre(can,arbresaitoacces,[self.centre[0]-200,self.centre[1]],self.direction,self.h,self.rayon,self.factor)
		vec1=[dicriticite1[self.arbre.etiquette.index(l)] for l in etiacces]		
		dessinsaito.graphecoordonnees_calcul()
		dessinsaito.dessinesaito(vec1,False,True)

		rang=[l[0] for l in nouvellesetiquettes].index(self.eti)
		nouvellesetiquettes[rang][1]+=1
		rang=[l[0] for l in nouvellesetiquettes].index(self.eti2)
		nouvellesetiquettes[rang][1]+=-1
		dicriticite2=Saito(self.arbre.proximite,nouvellesetiquettes)				
		Val2=matrix(self.arbre.proximite).inverse()*matrix([[l[1]] for l in nouvellesetiquettes])
		indices=[self.arbre.etiquette.index(l) for l in etiacces]	
		Val2=list([Val2.transpose()[0][l] for l in indices])	
		Res2=self.invariantSquare(Val2,dicriticite2,etiacces)

		dessinsaito=DessinArbre(can,arbresaitoacces,[self.centre[0],self.centre[1]],self.direction,self.h,self.rayon,self.factor)
		vec1=[dicriticite2[self.arbre.etiquette.index(l)] for l in etiacces]		
		dessinsaito.graphecoordonnees_calcul()
		dessinsaito.dessinesaito(vec1,False,True)


		can.create_text(250,150,text=str(Val))
		can.create_text(250,200,text='Invariant Theta11 = '+str(Res1+Res2+len(etiacces)/2))

		can.pack()
		fen.mainloop()

################# Invariant Theta11Sym

	def entreeetiacces3sym(self):
		def recupere():
			self.eti=int(entree.get())
			self.eti2=int(entree2.get())		
			self.fen.destroy()
			self.dessine3sym()
		
		self.fen=Tk()
		self.fen.title('Labels')		
		
		Label(self.fen, text="Label 1").grid(row=0,column=0,sticky=W)		
		Label(self.fen, text="Label 2").grid(row=1,column=0,sticky=W)				
		entree = Entry(self.fen)				
		entree2 = Entry(self.fen)	
		entree.grid(row=0,column=1)
		entree2.grid(row=1,column=1)	

		bouton = Button(self.fen, text="Valider", command=recupere)
		bouton.grid(row=2,column=1)

		self.fen.mainloop()

	def dessine3sym(self):

		fen=Tk()
		fen.title('Saito foliation acces')	
		can=Canvas(fen,width=1000,height=800,bg="white")

		nouvellesetiquettes=triEtiquette(deepcopy(self.arbre.courbe))
		rang=[l[0] for l in nouvellesetiquettes].index(self.eti)
		nouvellesetiquettes[rang][1]+=1
		dicriticite1=Saito(self.arbre.proximite,nouvellesetiquettes)
		etiacces=self.etiquettearbreacces(self.eti)				
		Val=matrix(self.arbre.proximite).inverse()*matrix([[l[1]] for l in nouvellesetiquettes])
		indices=[self.arbre.etiquette.index(l) for l in etiacces]	
		Val=list([Val.transpose()[0][l] for l in indices])			
		Res1=self.invariantSquare(Val,dicriticite1,etiacces)
		proxacces=self.arbre.extract(etiacces)
		arbresaitoacces=ArbreDual(proxacces,etiacces,self.arbre.racine,self.arbre.courbe)
		dessinsaito=DessinArbre(can,arbresaitoacces,[self.centre[0]-200,self.centre[1]],self.direction,self.h,self.rayon,self.factor)
		vec1=[dicriticite1[self.arbre.etiquette.index(l)] for l in etiacces]		
		dessinsaito.graphecoordonnees_calcul()
		dessinsaito.dessinesaito(vec1,False,True)

		
		nouvellesetiquettes=triEtiquette(deepcopy(self.arbre.courbe))
		rang=[l[0] for l in nouvellesetiquettes].index(self.eti2)
		nouvellesetiquettes[rang][1]+=1
		dicriticite2=Saito(self.arbre.proximite,nouvellesetiquettes)
		Res11=dicriticite2[[l[0] for l in nouvellesetiquettes].index(self.eti)][1]
		etiacces=self.etiquettearbreacces(self.eti)				
		Val=matrix(self.arbre.proximite).inverse()*matrix([[l[1]] for l in nouvellesetiquettes])
		indices=[self.arbre.etiquette.index(l) for l in etiacces]	
		Val2=list([Val.transpose()[0][l] for l in indices])	
		Res2=self.invariantSquare(Val2,dicriticite2,etiacces)
		proxacces=self.arbre.extract(etiacces)
		arbresaitoacces=ArbreDual(proxacces,etiacces,self.arbre.racine,self.arbre.courbe)
		dessinsaito=DessinArbre(can,arbresaitoacces,[self.centre[0],self.centre[1]],self.direction,self.h,self.rayon,self.factor)
		vec1=[dicriticite2[self.arbre.etiquette.index(l)] for l in etiacces]		
		dessinsaito.graphecoordonnees_calcul()
		dessinsaito.dessinesaito(vec1,False,True)
		
		###
		
		nouvellesetiquettes=triEtiquette(deepcopy(self.arbre.courbe))
		rang=[l[0] for l in nouvellesetiquettes].index(self.eti)
		nouvellesetiquettes[rang][1]+=1
		dicriticite2=Saito(self.arbre.proximite,nouvellesetiquettes)
		Res12=dicriticite2[[l[0] for l in nouvellesetiquettes].index(self.eti2)][1]
		etiacces2=self.etiquettearbreacces(self.eti2)				
		Val=matrix(self.arbre.proximite).inverse()*matrix([[l[1]] for l in nouvellesetiquettes])
		indices=[self.arbre.etiquette.index(l) for l in etiacces2]	
		Val2=list([Val.transpose()[0][l] for l in indices])	
		Res3=self.invariantSquare(Val2,dicriticite2,etiacces2)
		proxacces=self.arbre.extract(etiacces2)
		arbresaitoacces=ArbreDual(proxacces,etiacces2,self.arbre.racine,self.arbre.courbe)
		dessinsaito=DessinArbre(can,arbresaitoacces,[self.centre[0]+200,self.centre[1]],self.direction,self.h,self.rayon,self.factor)
		vec1=[dicriticite2[self.arbre.etiquette.index(l)] for l in etiacces2]		
		dessinsaito.graphecoordonnees_calcul()
		dessinsaito.dessinesaito(vec1,False,True)

		nouvellesetiquettes=triEtiquette(deepcopy(self.arbre.courbe))
		rang=[l[0] for l in nouvellesetiquettes].index(self.eti2)
		nouvellesetiquettes[rang][1]+=1
		dicriticite2=Saito(self.arbre.proximite,nouvellesetiquettes)
		etiacces2=self.etiquettearbreacces(self.eti2)				
		Val=matrix(self.arbre.proximite).inverse()*matrix([[l[1]] for l in nouvellesetiquettes])
		indices=[self.arbre.etiquette.index(l) for l in etiacces2]	
		Val2=list([Val.transpose()[0][l] for l in indices])	
		Res4=self.invariantSquare(Val2,dicriticite2,etiacces2)
		proxacces=self.arbre.extract(etiacces2)
		arbresaitoacces=ArbreDual(proxacces,etiacces2,self.arbre.racine,self.arbre.courbe)
		dessinsaito=DessinArbre(can,arbresaitoacces,[self.centre[0]+400,self.centre[1]],self.direction,self.h,self.rayon,self.factor)
		vec1=[dicriticite2[self.arbre.etiquette.index(l)] for l in etiacces2]		
		dessinsaito.graphecoordonnees_calcul()
		dessinsaito.dessinesaito(vec1,False,True)
		
		###


		can.create_text(250,150,text=str(Val))
		can.create_text(250,200,text='Invariant Theta11 symetrique = '+str(Res1+Res2+Res3+Res4+len(etiacces)/2+len(etiacces2)/2+Res11+Res12))

		can.pack()
		fen.mainloop()
		
		
	

################# Invariant Theta2Sym

	def entreeetiacces2sym(self):
		def recupere():
			self.eti=int(entree.get())
			self.eti2=int(entree2.get())		
			self.fen.destroy()
			self.dessine2sym()
		
		self.fen=Tk()
		self.fen.title('Labels')		
		
		Label(self.fen, text="Label 1").grid(row=0,column=0,sticky=W)		
		Label(self.fen, text="Label 2").grid(row=1,column=0,sticky=W)				
		entree = Entry(self.fen)				
		entree2 = Entry(self.fen)	
		entree.grid(row=0,column=1)
		entree2.grid(row=1,column=1)	

		bouton = Button(self.fen, text="Valider", command=recupere)
		bouton.grid(row=2,column=1)

		self.fen.mainloop()

	def dessine2sym(self):

		fen=Tk()
		fen.title('Saito foliation acces')	
		can=Canvas(fen,width=1000,height=800,bg="white")

		nouvellesetiquettes=triEtiquette(deepcopy(self.arbre.courbe))
		dicriticite1=Saito(self.arbre.proximite,nouvellesetiquettes)
		Res11=dicriticite1[[l[0] for l in nouvellesetiquettes].index(self.eti)][1]
		print(dicriticite1)
		print(Res11)
		etiacces=self.etiquettearbreacces(self.eti)
		#print(etiacces)				
		Val=matrix(self.arbre.proximite).inverse()*matrix([[l[1]] for l in self.arbre.courbe])
		indices=[self.arbre.etiquette.index(l) for l in etiacces]	
		Val=list([Val.transpose()[0][l] for l in indices])			
		Res1=self.invariantSquare(Val,dicriticite1,etiacces)
		
		
		proxacces=self.arbre.extract(etiacces)
		arbresaitoacces=ArbreDual(proxacces,etiacces,self.arbre.racine,self.arbre.courbe)
		dessinsaito=DessinArbre(can,arbresaitoacces,[self.centre[0]-200,self.centre[1]],self.direction,self.h,self.rayon,self.factor)
		vec1=[dicriticite1[self.arbre.etiquette.index(l)] for l in etiacces]		
		dessinsaito.graphecoordonnees_calcul()
		dessinsaito.dessinesaito(vec1,False,True)

		rang=[l[0] for l in nouvellesetiquettes].index(self.eti)
		nouvellesetiquettes[rang][1]+=1
		rang=[l[0] for l in nouvellesetiquettes].index(self.eti2)
		nouvellesetiquettes[rang][1]+=1
	
		dicriticite2=Saito(self.arbre.proximite,nouvellesetiquettes)				
		Val2=matrix(self.arbre.proximite).inverse()*matrix([[l[1]] for l in nouvellesetiquettes])
		indices=[self.arbre.etiquette.index(l) for l in etiacces]	
		Val2=list([Val2.transpose()[0][l] for l in indices])	
		Res2=self.invariantSquare(Val2,dicriticite2,etiacces)

		dessinsaito=DessinArbre(can,arbresaitoacces,[self.centre[0],self.centre[1]],self.direction,self.h,self.rayon,self.factor)
		vec1=[dicriticite2[self.arbre.etiquette.index(l)] for l in etiacces]		
		dessinsaito.graphecoordonnees_calcul()
		dessinsaito.dessinesaito(vec1,False,True)
		
		###
		
		nouvellesetiquettes=triEtiquette(deepcopy(self.arbre.courbe))
		dicriticite1=Saito(self.arbre.proximite,nouvellesetiquettes)
		etiacces2=self.etiquettearbreacces(self.eti2)
		#print(etiacces2)				
		Val=matrix(self.arbre.proximite).inverse()*matrix([[l[1]] for l in self.arbre.courbe])
		indices=[self.arbre.etiquette.index(l) for l in etiacces2]	
		Val=list([Val.transpose()[0][l] for l in indices])			
		Res3=self.invariantSquare(Val,dicriticite1,etiacces2)
		Res31=dicriticite1[[l[0] for l in nouvellesetiquettes].index(self.eti2)][1]
		print(dicriticite1)
		print(Res31)

		proxacces=self.arbre.extract(etiacces2)
		arbresaitoacces=ArbreDual(proxacces,etiacces2,self.arbre.racine,self.arbre.courbe)
		dessinsaito=DessinArbre(can,arbresaitoacces,[self.centre[0]+200,self.centre[1]],self.direction,self.h,self.rayon,self.factor)
		vec1=[dicriticite1[self.arbre.etiquette.index(l)] for l in etiacces2]		
		dessinsaito.graphecoordonnees_calcul()
		dessinsaito.dessinesaito(vec1,False,True)

		rang=[l[0] for l in nouvellesetiquettes].index(self.eti)
		nouvellesetiquettes[rang][1]+=1
		rang=[l[0] for l in nouvellesetiquettes].index(self.eti2)
		nouvellesetiquettes[rang][1]+=1
	
		dicriticite2=Saito(self.arbre.proximite,nouvellesetiquettes)				
		Val2=matrix(self.arbre.proximite).inverse()*matrix([[l[1]] for l in nouvellesetiquettes])
		indices=[self.arbre.etiquette.index(l) for l in etiacces2]	
		Val2=list([Val2.transpose()[0][l] for l in indices])	
		Res4=self.invariantSquare(Val2,dicriticite2,etiacces2)

		dessinsaito=DessinArbre(can,arbresaitoacces,[self.centre[0]+400,self.centre[1]],self.direction,self.h,self.rayon,self.factor)
		vec1=[dicriticite2[self.arbre.etiquette.index(l)] for l in etiacces2]		
		dessinsaito.graphecoordonnees_calcul()
		dessinsaito.dessinesaito(vec1,False,True)
		
		###


		can.create_text(250,150,text=str(Val))
		can.create_text(250,200,text='Invariant Theta2 symetrique = '+str(Res1+Res2+Res3+Res4+len(etiacces)/2+len(etiacces2)/2+Res11+Res31))

		can.pack()
		fen.mainloop()
		
		
	
