

class ArbreDual():
	def __init__(self,P,E,R,C):
		self.proximite=P
		self.etiquette=E
		self.racine=R
		self.courbe=C
		self.listesousgraphe=[]

	def extract(self,L):
		Index=[]
		for l in L:
			Index+=[self.etiquette.index(l)]		
		return([[self.proximite[i][j] for j in Index] for i in Index])

	def taille(self):
		return(len(self.proximite))

	def intersection(self):
		return(list(matrix(self.proximite)*matrix(self.proximite).transpose()))

	def voisinage(self,i):
		Int=self.intersection()
		ind=self.etiquette.index(i)
		#print(ind)
		return([self.etiquette[l] for l in range(0,self.taille()) if Int[l][ind]==-1])
	
	
	def blowup(self,cent):
		print(cent)
		if len(cent)>0:
			if len(cent)==1 and cent[0] in self.etiquette:
				self.etiquette=self.etiquette+[max(self.etiquette)+1]
				self.courbe=self.courbe+[[self.etiquette[-1],0]]
				self.proximite=[l+[0] for l in self.proximite]						
				self.proximite=self.proximite+[[0 for v in range(0,self.taille()+1)]]			
				self.proximite[-1][-1]=1
				self.proximite[self.etiquette.index(cent[0])][-1]=-1
			else:
				if cent[0] in self.etiquette and cent[1] in self.etiquette and self.intersection()[self.etiquette.index(cent[0])][self.etiquette.index(cent[1])]==-1:
					self.etiquette=self.etiquette+[max(self.etiquette)+1]
					self.courbe=self.courbe+[[self.etiquette[-1],0]]
					self.proximite=[l+[0] for l in self.proximite]						
					self.proximite=self.proximite+[[0 for v in range(0,self.taille()+1)]]			
					self.proximite[-1][-1]=1
					self.proximite[self.etiquette.index(cent[0])][-1]=-1
					self.proximite[self.etiquette.index(cent[1])][-1]=-1
		else:
			pass
	
	def contract(self,cent):
		#print(' contraction=',cent)
		if len(cent)==1 and not cent[0]==self.racine:
			try:
				if self.intersection()[self.etiquette.index(cent[0])][self.etiquette.index(cent[0])]==1:				
					u=[i[0] for i in self.courbe].index(cent[0])
					self.courbe.remove(self.courbe[u])				
					#print(self.etiquette)				
					L=deepcopy(self.etiquette)
					L.remove(cent[0])
					#print(self.etiquette)
					self.proximite=self.extract(L)
					self.etiquette.remove(cent[0])
				else:
					pass
			except:
				pass	
				
	
	def proximate(self,eti):
		ind=self.etiquette.index(eti)
		return([self.etiquette[l] for l in range(0,self.taille()) if self.proximite[l][ind]==-1])

	def addcurve(self,cent):
		noeud=[l[0] for l in self.courbe].index(cent[0])
		self.courbe[noeud][1]+=1

	def removecurve(self,cent):
		noeud=[l[0] for l in self.courbe].index(cent[0])
		if self.courbe[noeud][1]>0:		
			self.courbe[noeud][1]+=-1

	def sousgraphe(self):
		self.listesousgraphe=[]		
		if self.taille()==1:
			return([])
		else:
			Voisins=self.voisinage(self.racine)			
			for l in Voisins:		
				Res=[]		
				ADD1=[l]
				while not set(Res)==set(ADD1):			
					Res=ADD1
					#print(ADD1)					
					for v in ADD1:
						ajout=self.voisinage(v)							
						if self.racine in ajout:							
							ajout.remove(self.racine)
						ADD1=ADD1+ajout	
					ADD1=list(set(ADD1))					
				Res.sort()				
				#print(eti)
				#print(self.courbe)				
				CC=[]				
				for u in Res:
					CCindex=[f[0] for f in self.courbe].index(u)					
					CC.append(self.courbe[CCindex])						
				self.listesousgraphe.append(ArbreDual(self.extract(Res),Res,l,CC))
		
	def sousarbreacces(self,eti):
		rang=self.etiquette.index(eti)
		#print(rang)
		if rang==0:
			return([self.etiquette[0]])
		else:
			parent=[l[rang] for l in self.proximite].index(-1)
			#print(parent)
			return(self.sousarbreacces(self.etiquette[parent])+[eti])

	def sousproximiteacces(self,eti):
		return(self.extract(self.proximite,self.sousarbreacces(eti)))	

	def valuation(self,eti):
		val=list(matrix(self.proximite).inverse()[0])		
		return(val[self.etiquette.index(eti)])

	def arbrecourbevaluation(self):
		return(list(matrix(self.proximite).inverse()*matrix([[l[1]] for l in self.courbe]))[0][0])

	def arbrecourbemilnor(self):
		return(Milnor(self.proximite,triEtiquette(deepcopy(self.courbe))))			

	def arbrecourbedimension(self):
		return(DimensionModGen(self.proximite,triEtiquette(deepcopy(self.courbe))))	

	def arbrecourbemodularite(self):
		return(Modularity(self.proximite,triEtiquette(deepcopy(self.courbe))))

	def arbrecourbetjurina(self):
		return(self.arbrecourbemilnor()-self.arbrecourbemodularite()+self.arbrecourbedimension())
		
